//-----------------------------------------------------
//
//	RIFF read program.
//
//-----------------------------------------------------

#include <string.h>
#include "iodefine.h"
#include "r8c_utils.h"
#include "r8c_macro.h"
#include "riff.h"


static TRiffInfo RiffInfo;

//f[^o͂܂
void riff_out()
{
	WORD n, i;

	n = RiffInfo.count;
	if ( n ) {
		RiffInfo.count = --n;
		i = RiffInfo.idx_r;
		trdgrd1 = RiffInfo.buff[i++] + 0x10;
		if( i>=sizeof(RiffInfo.buff) ) i = 0;
		RiffInfo.idx_r = i;
	}
}
//-----------------------------------------------------

//RIFFt@CPCMf[^ǂݏo܂
void riff_read()
{
	TRiffLabel label;
	FRESULT res;
	long len;
	UINT n;
	WORD i;
	
	//ubN̏I_
	if ( RiffInfo.pos>=RiffInfo.end ) {
		
		//f[^ubN܂Ői߂܂
		while (1) {
			res = f_read(&RiffInfo.src, &label, sizeof(TRiffLabel), &n);
			
			if ( res!=FR_OK ) return;
			
			if ( memcmp(label.id, "data", 4)!=0 )
				f_lseek(&RiffInfo.src, label.size);
			else
				break;
		}
		
		//ubNTCYƃ|C^ݒ
		RiffInfo.pos = 0;
		RiffInfo.end = label.size;
	}
	
	//1ubN󂫂ꍇ
	if ( RiffInfo.count<=RIFF_BLOCKSIZE ) {
		
		len = RiffInfo.end - RiffInfo.pos;
		i = RiffInfo.idx_w;
		if ( len<RIFF_BLOCKSIZE ) {
			f_read(&RiffInfo.src, RiffInfo.buff + i, len, &n);
		}
		else {
			f_read(&RiffInfo.src, RiffInfo.buff + i, RIFF_BLOCKSIZE, &n);
		}
		
		DI();
		RiffInfo.count += n;
		EI();
		i += n;
		if ( i>=sizeof(RiffInfo.buff) ) i = 0;
		RiffInfo.idx_w = i;
		RiffInfo.pos += n;
	}
}
//-------------------------------------------------------

//RIFFt@CJ܂
void riff_open(const char* src)
{
	int n;
	TRiffLabel label;
	FIL* fp = &RiffInfo.src;
	
	//RIFF\̂̏
	memset( &RiffInfo.riff, 0, sizeof(TRiffHead));
	memset( &RiffInfo.fmt, 0, sizeof(TFmtChunk));
	RiffInfo.end = 0;
	RiffInfo.pos = 0;
	
	//FIFO
	RiffInfo.idx_w = 0;
	RiffInfo.idx_r = 0;
	RiffInfo.count = 0;
	
	//t@CI[v
	if ( f_open(fp, src, FA_READ | FA_OPEN_EXISTING)!=FR_OK )
		goto RIFF_OPEN_ERROR;
		
	//RIFFwb_ǂݍ݁`FbN
	f_read(fp, &(RiffInfo.riff), sizeof(TRiffHead), &n);
	if ( memcmp(RiffInfo.riff.id, "RIFF", 4)!=0 || memcmp(RiffInfo.riff.type, "WAVE", 4)!=0 )
		goto RIFF_OPEN_ERROR;
		
	//fmt`Nǂݍ݁`FbN
	f_read(fp, &label, sizeof(TRiffLabel), &n);
	if ( memcmp(label.id, "fmt ", 4)!=0 ) goto RIFF_OPEN_ERROR;
	f_read(fp, &RiffInfo.fmt, sizeof(TFmtChunk), &n);
	if ( RiffInfo.fmt.id!=RIFF_IDPCM || RiffInfo.fmt.ch!=1 ) goto RIFF_OPEN_ERROR;
	
	//I
	return;

	
//G[
RIFF_OPEN_ERROR:

	f_close(fp);
	return;
}
//-------------------------------------------------------

//RIFFt@C܂
void riff_close()
{
	f_close( &RiffInfo.src );
}
//-------------------------------------------------------

